%% Lorenz equation
clear all; close all;
addpath ./../ODE_Solvers/

%% If the right hand side is easy
f = @(t,x) [-8/3*x(1) + x(2)*x(3);
            -10*x(2) + 10*x(3);
            -x(1)*x(2) + 28*x(2) - x(3)];
%% Initial data       
t_final = 100; x0 = [0; 0; 1e-10];

%%

%[t, x] = ode45(f, [0, t_final], x0);
%[t1, x1] = rk_4(@lorenz, [0, t_final, 0.05], x0);
%[t1, x1] = rk_4(f, [0, t_final, 0.05], x0);

%%
butterfly = @(t,x) lorenz_file(t, x, 8/3, 10, 28);
[t, x] = abm3pc(butterfly, [0, t_final, 0.01], x0);
%%
figure(1); plot(t, x);
figure(2); plot3(x(:,1), x(:,2), x(:,3)); grid
%axis([10 42 -20 20 -20 25]); 

%%
figure(3); plot(t1, x1);
figure(4); plot3(x1(:,1), x1(:,2), x1(:,3)); grid
axis([10 42 -20 20 -20 25]); 