function [tout, xout] = ab3_rk3(odefunc, tspan, x0)
%AB_RK3 Summary of this function goes here
%   Detailed explanation goes here

ts = tspan; t0 = ts(1); th = ts(2); 
% better to initialize the size, but
xout = x0(:)'; tout = t0; x0 = x0(:);

if length(ts) == 3
    h = ts(3);
else
    h = (ts(2) - ts(1))/100;
    %th = ts(2);
end

% initialize to start using rk3o
i=1; k = [];
for t = [t0, t0+h]
    k1 = h*feval(odefunc, t, x0);
    k2 = h*feval(odefunc, t+h/2, x0+k1/2);
    k3 = h*feval(odefunc, t+3*h/4, x0+3*k2/4);
    x0 = x0 + (2*k1 + 3*k2 + 4*k3)/9;
    xout = [xout; x0']; tout = [tout; t+h];
    % for later use
    k(:,i) = k1; i = i + 1;
end

% ab3 method
for t = (t0+2*h):h:(th-h)
    k(:,i) =  h*feval(odefunc, t, x0); % check i and x0
    x0 = x0 + (23*k(:,i) - 16*k(:,i-1) + 5*k(:,i-2))/12;
    xout = [xout; x0']; tout = [tout; t+h];
    i = i + 1;
end

end
