function [tout, xout] = abm3pc(odefunc, tspan, x0)
%AB_RK3 Summary of this function goes here
%   Detailed explanation goes here

ts = tspan; t0 = ts(1); th = ts(2); 
% better to initialize the size, but
xout = x0(:)'; tout = t0; x0 = x0(:);

if length(ts) == 3
    h = ts(3);
else
    h = (ts(2) - ts(1))/100;
    %th = ts(2);
end

% initialize to start using mid-point
i=1; k = [];
for t = [t0, t0+h]
    k1 = h*feval(odefunc, t, x0);
    k2 = h*feval(odefunc, t+h/2, x0+k1/2);
    %k3 = h*feval(odefunc, t+3*h/4, x0+3*k2/4);
    %x0 = x0 + (2*k1 + 3*k2 + 4*k3)/9;
    % or using mid-point rule
    x0 = x0 + k2;
    xout = [xout; x0']; tout = [tout; t+h];
    % for later use
    k(:,i) = k1; i = i + 1;
end

% ab3 method
for t = (t0+2*h):h:(th-h)
    % predict x0 by x00
    k(:,i) =  h*feval(odefunc, t, x0); % check i and x0
    x00 = x0 + (23*k(:,i) - 16*k(:,i-1) + 5*k(:,i-2))/12;
    % correct x00 to get x0
    tempf = h*feval(odefunc, t, x00);
    x0 = x0 + (5*tempf + 8*k(:,i) - k(:,i-1))/12;
    xout = [xout; x0']; tout = [tout; t+h];
    i = i + 1;
end

end
