function [tout, xout] = rk_3o(odefunc, tspan, x0)
%RK_3o Summary of this function goes here
%   Detailed explanation goes here

ts = tspan; t0 = ts(1); th = ts(2); 
% better to initialize the size, but
xout = x0(:)'; tout = t0; x0 = x0(:);

if length(ts) == 3
    h = ts(3);
else
    h = (ts(2) - ts(1))/100;
    %th = ts(2);
end

for t = t0:h:th-h
    k1 = h*feval(odefunc, t, x0);
    k2 = h*feval(odefunc, t+h/2, x0+k1/2);
    k3 = h*feval(odefunc, t+3*h/4, x0+3*k2/4);
    x0 = x0 + (2*k1 + 3*k2 + 4*k3)/9;
    xout = [xout; x0']; tout = [tout; t+h];
end

end % of function
