function [tout, xout] = rk_4(odefunc, tspan, x0)
%RK_4 Summary of this function goes here
%   Detailed explanation goes here

ts = tspan; t0 = ts(1); th = ts(2); 
% better to initialize the size, but
xout = x0(:)'; tout = t0; x0 = x0(:);

if length(ts) == 3
    h = ts(3);
else
    h = (ts(2) - ts(1))/100;
    %th = ts(2);
end

for t = t0:h:th-h
    k1 = h*feval(odefunc, t, x0);
    k2 = h*feval(odefunc, t+h/2, x0+k1/2);
    k3 = h*feval(odefunc, t+h/2, x0+k2/2);
    k4 = h*feval(odefunc, t+h, x0+k3);
    x0 = x0 + (k1 + 2*k2 + 2*k3 + k4)/6;
    xout = [xout; x0']; tout = [tout; t+h];
end

end % of function
